#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.3.14.2
	Author:         dasda

	Script Function:
	Filminformationen zur Anreicherung des Neutrino-Moviebrowsers herunterladen/erstellen.
	Fr eine schnere Ansicht im MB werden die Filmcover und Filminformationen von filmstarts.de geladen.
	Zustzlich wird mit den auf filmstarts.de gefundenen Titeln nach Informationen, wie Rating, auf IMDB gesucht
	Zustzlich knnen Datei-Eigenschaften per MediaInfo_i386.dll gespeichert werden.

#ce ----------------------------------------------------------------------------

#include "09 - includes.au3"

Global $sVersion = 0.9
Global $sName = "Video_Info_Grabber" & " " & $sVersion
Global $Ini = StringTrimRight(@ScriptDir, 3) & "Data\Einstellungen.txt"


; Wenn keine ini vorhanden ist, wird sie erstellt und das Programm beendet.
If Not FileExists($Ini) Then
	FileWrite($Ini, 'Hinweise:' & @CRLF & '- Das Programm legt die Ergebnisse in jedem Ordner den es bearbeitet in einen neuen Ordner, mit dem Programmnamen ab, damit nichts versehentlich berschrieben wird.' & @CRLF & '  (Kann unten per "Ergebnisse in das Filmverzeichnis=1" gendert werden.)' & @CRLF & '- Jeder bernommene Treffer, oder jede Datei bei der "dauerhaft ignorieren" gewhlt wurde, wird in eine Ignorierliste hier im Verzeichnis geschrieben.' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, '[Einstellungen]' & @CRLF & 'Ein Wert 1 bei "Rekursive Suche" sorgt dafr, dass auch Unterordner durchsucht werden.' & @CRLF & 'Bei jedem anderen Wert, bleibt die Suche auf den gewhlten Ordner beschrnkt:' & @CRLF & @CRLF & 'Rekursive Suche=0' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Der Wert 1 bei "Automatik" sorgt fr die direkte bernahme wenn einer der Treffer wortgleich ist.' & @CRLF & 'Wird hier der Wert 2 eingetragen, werden Filme auch bernommen, wenn das Ergebnis eindeutig scheint, weil nur ein Suchtreffer gefunden wurde.' & @CRLF & 'Bei Wert 3 bearbeitet das Programm in Batchverarbeitung jeden eindeutigen, wortgleichen Treffer und bergeht die anderen.' & @CRLF & 'Bei Wert 4 bernimmt das Programm in Batchverarbeitung jeden wortgleichen Treffer und alle Einzeltreffer. Alle anderen werden bergangen.' & @CRLF & @CRLF & "Automatik=1" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Bei Wert 1 von "Ergebnisse in das Filmverzeichnis" werden die heruntergeladenen Filminformationen' & @CRLF & 'nicht in einem getrennten Ergebnisordner abgelegt werden, sondern direkt bei der Filmdatei.' & @CRLF & 'Achtung: Vorhandene Dateien werden ohne Nachfrage berschrieben!' & @CRLF & @CRLF & "Ergebnisse in das Filmverzeichnis=0" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, '"Cover/XML" kennt drei Stati. Bei allen Werten auer 2 und 3 werden Cover geladen und XML erstellt.' & @CRLF & 'Bei Wert 2 werden nur die Cover geladen.' & @CRLF & 'Bei Wert 3 werden nur die XML erstellt.' & @CRLF & @CRLF & 'Cover/XML=1' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Der Wert 1 bei "Sendernamenfilter" sorgt fr das Filtern der Sendernamen aus dem Suchbegriff.' & @CRLF & 'Vorraussetzung hierfr ist die Angabe der IP Adresse eines Receivers, von dem die Senderliste abgerufen werden kann.' & @CRLF & 'Hier kann es auch sinnvoll den Zeichensatz UTF8 einzustellen (UTF8=1), falls dies der Zeichtensatz des Systems ist.' & @CRLF & @CRLF & 'Sendernamenfilter=0' & @CRLF & 'IP=192.168.178.30' & @CRLF & 'UTF8=0' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Der Wert 1 bei "Dateibeschreibung" sorgt dafr,' & @CRLF & "dass Info 2 noch zustzliche Informationen angehngt werden (Container, Codec, Auflsung und Video-Bitrate)." & @CRLF & 'Jede nderung dieses Eintrags verhindert das.' & @CRLF & @CRLF & "Dateibeschreibung=1" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Bei Wert 1 von "Info1" bietet das Programm an,' & @CRLF & "einen Titel, der : oder - beinhaltet aufzusplitten und den ersten Teil als Namen, den zweiten Teil als Info1" & @CRLF & 'zu verwenden. Bei Wert 0 wird nichts eingetragen und bei jedem anderen Wert werden automatisch die Grenreangaben als Info1 bernommen.' & @CRLF & @CRLF & "Info1=2" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Der Wert 1 bei "Dateinamenbereinigung" bedeutet, dass der gefundene Titel als neuer Dateiname verwendet wird.' & @CRLF & 'Jede nderung dieses Eintrags verhindert das.' & @CRLF & 'Bei meinen Tests mit einer Samba-Freigabe auf den Receiver funktionierte diese Option nicht. Hier also deaktivieren, damit die XML passen.' & @CRLF & @CRLF)
	FileWrite($Ini, 'Der Wert 1 bei "Unterstriche" bedeutet, dass die umbenannte Datei Unterstriche, statt Leerzeichen beinhaltet.' & @CRLF & "Jede nderung dieses Eintrags sorgt fr Leerzeichen." & @CRLF & @CRLF)
	FileWrite($Ini, 'Dateinamenbereinigung=0' & @CRLF & 'Unterstriche=0' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Der Wert 1 bei "MediaInfotext" sorgt dafr, dass zu jedem Titel' & @CRLF & 'die allgemeine MediaInfo-Ausgabe als Textdatei in einem Unterordner des Ergebnisordners abgelegt wird.' & @CRLF & 'Bei Wert 2 werden nur diese Infodateien im Batchverfahren geschrieben.' & @CRLF)
	FileWrite($Ini, 'Bei Wert 3 werden alle Filme im Batchverfahren nach ihrer Auflsung in Unterordner sortiert (Full HD, HD Ready, SD).' & @CRLF & @CRLF & "MediaInfotext=0" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Hier folgt das "Startverzeichnis" der Suche.' & @CRLF & 'Du kannst es erst einmal ignorieren.' & @CRLF & 'Hier wird immer der letzte gewhlte Pfad gespeichert.' & @CRLF & @CRLF & 'Startverzeichnis=' & @DesktopDir & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	FileWrite($Ini, 'Der Wert 1 bei "Tonspuren" sorgt dafr, dass die vorhandenen Tonspuren in die XML eingetragen werden.' & @CRLF & 'Das ist nicht ntig, da Neutrino diese selbst ermittelt. Wichtiger ist aber:' & @CRLF & 'Stand 20.05.2015 kann es zu schweren Problemen fhren, wenn diese Funktion aktiviert wird!' & @CRLF & 'Also bei Fremdformat-Filmen besser deaktiviert lassen!' & @CRLF & @CRLF & "Tonspuren=0" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF)
	MsgBox(0, $sName, 'Erster Start!' & @CRLF & @CRLF & 'Konfiguriere das Programm in der Einstellungen.txt im Ordner "Data".')
	Exit
EndIf

; Wenn die MediaInfo.dll nicht vorhanden ist, wird eine Benachrichtigung eingeblendet und das Programm beendet.
If Not FileExists(StringTrimRight(@ScriptDir, 3) & "Other\MediaInfo_i386.dll") Then
	MsgBox(0, "Fehlende Datei!", "MediaInfo_i386.dll fehlt im Programmverzeichnis." & @CRLF & "Das Programm wird beendet.", 10)
	Exit
EndIf

Break(0) ; Deaktiviert das Tray-Icon - es reagiert nicht mehr auf Klicks.

; In den nchsten Zeilen wird erst geprft, ob eine Programmverknpfung im Verzeichnis der .vbs liegt. Wenn nicht werden dort und auf dem Desktop Verknpfungen erstellt.

$sVBSPath = StringTrimRight(@ScriptDir, 3)
$sShortcutFPath1 = @DesktopDir & "\" & $sName & ".lnk"
$sShortcutFPath2 = $sVBSPath & $sName & ".lnk"

$aDetails = FileGetShortcut($sShortcutFPath2)
If @error Then
	FileCreateShortcut($sVBSPath & "Video_Info_Grabber.vbs", $sShortcutFPath1, @WindowsDir, "", _
			"Video-Informationen fr den Moviebrowser erstellen", StringTrimRight(@ScriptDir, 3) & "\Other\Icon.ico", "^!t")
	FileCreateShortcut($sVBSPath & "Video_Info_Grabber.vbs", $sShortcutFPath2, @WindowsDir, "", _
			"Video-Informationen fr den Moviebrowser erstellen", StringTrimRight(@ScriptDir, 3) & "\Other\Icon.ico", "^!t")
	MsgBox(0, $sName, "Es wurden Programmverknpfungen im Programmverzeichnis und auf dem Desktop erstellt." & @CRLF & @CRLF & "Zum erneuten Erstellen die Verknpfung im Programmverzeichnis lschen.")
EndIf


; Das MediaInfo Handle wird erstellt.
Global $hDLL = DllOpen(StringTrimRight(@ScriptDir, 3) & "Other\MediaInfo_i386.dll")
Global $aMediaInfo = DllCall($hDLL, "ptr", "MediaInfo_New")
Global $hMediaInfo = $aMediaInfo[0]

; Die Einstellungen werden in Variablen gelesen.
Global $sNoConfirmation = IniRead($Ini, "Einstellungen", "Automatik", "")
Global $sBorrowing = IniRead($Ini, "Einstellungen", "Dateinamenbereinigung", "")
Global $sUnderlines = IniRead($Ini, "Einstellungen", "Unterstriche", "")
Global $sExtInfo = IniRead($Ini, "Einstellungen", "Dateibeschreibung", "")
Global $sMediaInfoText = IniRead($Ini, "Einstellungen", "MediaInfotext", "")
Global $sRecursive = IniRead($Ini, "Einstellungen", "Rekursive Suche", "")
Global $sAudioInfos = IniRead($Ini, "Einstellungen", "Tonspuren", "")
Global $sChannelMask = IniRead($Ini, "Einstellungen", "Sendernamenfilter", "")
Global $sIP = IniRead($Ini, "Einstellungen", "IP", "")
Global $sCharset = IniRead($Ini, "Einstellungen", "UTF8", "")
Global $sStartfolder = IniRead($Ini, "Einstellungen", "Startverzeichnis", "")
Global $sOutputFilter = IniRead($Ini, "Einstellungen", "Cover/XML", "")
Global $sInfo1Option = IniRead($Ini, "Einstellungen", "Info1", "")
Global $sNoExtraFolder = IniRead($Ini, "Einstellungen", "Ergebnisse in das Filmverzeichnis", "")


Global $sIMDB_Infos = 1


; Einige Arrays die ich fr Filterfunktionen nutze. $aSubstitutes etwa ist der Filter, um letzte html-tags aus den Filminformationen zu lschen.
Global $aSubstitutes[16][2] = [["<br />", ""], ["<b>", ""], ["</b>", ""], ["</a>", ""], ["<a href='", ""], ["'><img", ""], ["src='", ""], ["'", ""], ["<br>", ""], ["</br>", ""], [">", ""], ["<span", ""], ["</span", ""], ["</p", ""], ["<p", ""], ["&nbsp;", " "]]
Global $aMoviefilter[7][1] = [[".mkv"], [".ts"], [".avi"], [".divx"], [".mpg"], [".mp4"], [".mpeg"]]
Global $aWindowsCleanup[9][1] = [['/'], ['\'], [':'], ['*'], ['"'], ['?'], ['>'], ['<'], ['|']]
Global $aGenreNumbers[23][2] = [["Spielfilm", "16"], ["Drama", "16"], ["Krimi", "17"], ["Thriller", "17"], ["Action", "18"], ["Abenteuer", "18"], ["Western", "18"], ["Kriegsfilm", "18"], _
		["Sci-Fi", "19"], ["Fantasy", "19"], ["Horror", "19"], ["Romanze", "22"], ["Tragigkomdie", "20"], ["Komdie", "20"], ["Historie", "23"], ["Animation", "85"], _
		["Familie", "16"], ["Spionage", "17"], ["Dokumentation", "28"], ["Sport", "34"], ["Biografie", "131"], ["Musik", "96"]]
Global $aAscii[9][2] = [['', '%C3%9C'], ['', '%C3%BC'], ['', '%C3%96'], ['', '%C3%B6'], ['', '%C3%84'], ['', '%C3%A4'], [':', '%3A'], ['', 'ss'], ['"', '']]

; Hier wird der Senderlisten-Filter erstellt, wenn die entsprechende Option aktiviert ist.
If $sChannelMask = 1 Then
	Global $sReceiverURL = "http://" & $sIP & "/control/channellist", $sChannellist = _INetGetSource($sReceiverURL, True)
	If Not @error Then
		; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
		$dBinary = StringToBinary($sChannellist)
		$sConverted = BinaryToString($dBinary, 4)

		Global $aChannellist = StringSplit($sConverted, @LF)
		_ArrayDelete($aChannellist, 0)
		$iSearchlines = UBound($aChannellist)

		Global $aChannels[$iSearchlines - 1]
		For $i = 0 To $iSearchlines - 2
			$aChannels[$i] = StringTrimLeft($aChannellist[$i], 17) ; Sendernamenfilter wird gefllt.
		Next
		_ArraySort($aChannels, 1)
	Else
		$hErrorMSG = MsgBox(4, $sName, "Receiver ist nicht erreichbar." & @CRLF & @CRLF & "Soll ohne den Senderfilter fortgefahren werden?")
		If $hErrorMSG = 7 Then
			MsgBox(0, $sName, "Programm wird beendet.", 3)
			Exit
		Else
			$sChannelMask = 0
		EndIf
	EndIf
EndIf

Global $sFileOpenDialog = FileSelectFolder("Whle einen Filme-Ordner aus", $sStartfolder & "\", "All (*.*)")
If @error Then
	MsgBox(0, $sName, "Auswahl abgebrochen." & @CRLF & @CRLF & "Programm wird beendet.", 2)
	Exit
Else
	; Einige Deklarationen fr spter gebrauchte Variablen
	Global $sMovies = "", $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $sDuration = "", $sExtFileData = "", $sSoundtrack = "", $sReleaseYear = "", $sCountry = "", $sRating = ""

	; Das ausgewhlte Verzeichnis wird fr zuknftige Starts gespeichert.
	If $sStartfolder <> $sFileOpenDialog Then IniWrite($Ini, "Einstellungen", "Startverzeichnis", $sFileOpenDialog)

	; Hier wird geprft, ob die rekursive Suche aktiviert ist, und je nachdem wird die entsprechende Suche gestartet.
	If $sRecursive = 1 Then
		$aFolder = _FileListToArrayRec($sFileOpenDialog, "*", $FLTAR_FILES, $FLTAR_RECUR, $FLTAR_NOSORT, $FLTAR_FULLPATH)
	Else
		$aFolder = _FileListToArrayRec($sFileOpenDialog, "*", $FLTAR_FILES, $FLTAR_NORECUR, $FLTAR_NOSORT, $FLTAR_FULLPATH)
	EndIf

	; In dieser Schleife werden aus den gefundenen Dateien, die in $aMoviefilter definierten Dateitypen gefiltert.
	For $i = 0 To UBound($aFolder) - 1
		For $j = 0 To 5
			If StringInStr($aFolder[$i], $aMoviefilter[$j][0]) Then
				$sMovies &= $aFolder[$i] & "|"
				ExitLoop
			EndIf
		Next
	Next

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	If $sCharset = 1 Then
		$dBinary = StringToBinary($sMovies)
		$sMovies = BinaryToString($dBinary, 4)
	EndIf

	; Aus dem String wird ein Array gebildet.
	$aMovies = StringSplit($sMovies, "|")

	; Ignorierliste wird in ein Array geladen.
	$aIgnorelist = FileReadToArray(StringTrimRight(@ScriptDir, 3) & "Data\Ignorierliste.txt")

	; Hier wird (nach Prfungen) in Schleife die Suche nach allen gefilterten Dateitypen (Filmen) gestartet und einige umstndliche Stringanpassungen vorgenommen.
	For $i = 1 To UBound($aMovies) - 1
		$iGlobalRun = $i
		If $aMovies[$i] <> "" Then ; Wenn Filme vorhanden sind.
			$aPathSplit = _PathSplit($aMovies[$i], $sDrive, $sDir, $sFilename, $sExtension)
			$sMoviename = StringReplace($sFilename, "_", " ") ; Hier werden erst _ dann . durch Leerzeichen ersetzt, um die Suchergebnisse zu verbessen.
			$sMoviename = StringReplace($sMoviename, ".", " ")
			If StringInStr($sMoviename, "(") And StringInStr($sMoviename, ")") Then ; Hier folgt das Entfernen des Inhalts von Klammern
				$aMoviesplit = _StringBetween($sMoviename, "(", ")")
				For $j = 0 To UBound($aMoviesplit) - 1
					$sMoviename = StringReplace($sMoviename, "(" & $aMoviesplit[$j] & ")", "", 1)
				Next
			EndIf
			If StringLen($sMoviename) > 15 And Number(StringRight($sMoviename, 14)) <> 0 Then ; Hier wird ein eventuell vorhandenes Datum entfernt
				If StringInStr(StringRight($sMoviename, 14), " ") Then
					$sMoviename = StringTrimRight($sMoviename, 15)
				Else
					$sMoviename = StringTrimRight($sMoviename, 14)
				EndIf
			EndIf
			If $sChannelMask = 1 Then $sMoviename = _ChannelCleanup($sMoviename)
			$sMoviename = StringReplace($sMoviename, "   ", " - ")
			$sMoviename = StringReplace($sMoviename, "  ", " ")

			Global $iIgnoreList = _ArraySearch($aIgnorelist, $sFilename) ; Hier wird geprft, ob der aktuelle Film schon in der Ignorierliste steht.
			If @error And $sMediaInfoText <> 2 And $sMediaInfoText <> 3 Then _SearchMovies($sMoviename) ; ..wenn nicht (und der Batchmodus nicht aktiviert ist), wird die Suche gestartet.
			If $sMediaInfoText = 2 Or $sMediaInfoText = 3 Then _MediaInfo() ; Wenn der Batchmodus zum schreiben der MediaInfo-Datei-Informationen aktiviert ist, wird diese Ausgabe gestartet.
		EndIf
	Next
	ToolTip("Suche abgeschlossen! Programm wird beendet..", @DesktopWidth / 2 - 125, @DesktopHeight / 2, $sName)

	; MediaInfo.dll wird vor dem Beenden freigegeben.
	DllCall($hDLL, "none", "MediaInfo_Close", "ptr", $hMediaInfo); Hier wird die MediaInfo.dll aktiviert.
	DllClose($hDLL)
	Sleep(3000)
	Exit
EndIf


; In dieser Funktion wird die allgemeine Suche ausgefhrt und die Suchergebnisse ausgewertet.
Func _SearchMovies($sMoviename)
	ToolTip($sMoviename & $sExtension & " wird gesucht.." & ' (' & $iGlobalRun & '/' & $aMovies[0] & ')', @DesktopWidth / 2 - 125, @DesktopHeight / 2, $sName)
	Local $Adress = "http://www.filmstarts.de/suche/1/?q=" & StringReplace($sMoviename, " ", "+"), $sSearch = _INetGetSource($Adress, True)
	Local $aResults = _StringBetween($sSearch, 'Bitte Suche verfeinern :', '</div><!-- / searchenginezone -->')

	; Wenn $aResults ein Fehler ist, wurden keine Suchergebnisse geliefert
	If Not @error Then

		; Hier wird die Anzahl der gefundenen Filme ausgewertet
		$aTempSplit = StringSplit($aResults[0], "Treffer")
		$sCounttext = "Ergebnis"
		$iHits = $aTempSplit[1]
		If $iHits < 1 Or $iHits > 1 Then $sCounttext = "Ergebnisse"
		If $iHits <> 0 Then
			; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
			$dBinary = StringToBinary($aResults[0])
			$sConverted = BinaryToString($dBinary, 4)

			; Hier erstelle ich ein Array. (Der String wird beim Zeilenumbruch gesplittet)
			$aResultSplit = StringSplit($sConverted, @LF)

			; Die Arraygre des Ergebnis-Array wird auf maximal 20 gesetzt (erste Trefferseite der Website)
			If $iHits > 20 Then $iHits = 20

			; Ergebnis-Array wird mit der Treffermenge deklariert.
			Local $aResultnames[$iHits][4]

			; Damit zhle ich gleich den Index des Ergebnis-Array in der Schleife hoch
			Local $iCount = 0

			; Hier wird das $aResultSplit Array Zeile fr Zeile durchgegangen. "alt='" im Quelltext nehme ich dabei als Marker fr die gesuchten Informationen
			For $i = 0 To UBound($aResultSplit) - 1
				If StringInStr($aResultSplit[$i], "alt='") Then ; "alt='" in der Zeile $i gefunden wurde, befindet sich der Logolink eine Zeile darber, der Filmname drei Zeilen darunter...

					; Hier wird getestet, ob nach "alt'" wirklich Text kommt. Nur dann finden sich Filminformationen.
					$aTestResults = _StringBetween($aResultSplit[$i], "'", "'")

					If $aTestResults[0] <> "" Then
						; Ergebnis-Array wird gefllt, nachdem unerwnschte Zeichen entfernt wurden
						$aResultnames[$iCount][0] = _TextCleanup($aResultSplit[$i - 1]) ; Logolink
						$aResultnames[$iCount][1] = _TextCleanup($aResultSplit[$i + 3]) ; Filmname
						$aResultnames[$iCount][2] = "http://www.filmstarts.de" & _TextCleanup($aResultSplit[$i + 2]) ; Detail-Link.
						$LenTest = StringLen(_TextCleanup($aResultSplit[$i + 6]))
						If $LenTest = 4 Then $aResultnames[$iCount][3] = _TextCleanup($aResultSplit[$i + 6]) ; Jahr
						$LenTest = StringLen(_TextCleanup($aResultSplit[$i + 7]))
						If $LenTest = 4 Then $aResultnames[$iCount][3] = _TextCleanup($aResultSplit[$i + 7]) ; Jahr
						$iCount += 1
					EndIf
				EndIf
			Next
		EndIf

		Local $iTop = 30, $idPic[$iHits], $idLabel[$iHits], $iIgnore = "", $iIndex = ""

		If $sNoConfirmation = 1 Or $sNoConfirmation = 2 Or $sNoConfirmation = 3 Or $sNoConfirmation = 4 Then
			; Hier wird fr die automatische bernahme ("Automatik") geprft, ob in der Trefferliste ein genauer Treffer ist.
			If $iHits > 0 Then
				Local $aPerfectName = _ArrayFindAll($aResultnames, $sMoviename, 0, 0, 0, 0, 1)
				If Not @error Then
					; Wenn es nur einen Treffer mit korrektem Namen gibt, wird der Titel bernommen
					If UBound($aPerfectName) = 1 Then
						$iHits = 1
						$iIndex = $aPerfectName[0]
					EndIf
				EndIf


			EndIf

			; Hier wird $iIndex auf Null gesetzt, wenn es nur einen Suchtreffer gibt. So wird ein Titel auch bernommen, wenn es kein namensgleicher Treffer ist.
			If $sNoConfirmation = 2 Or $sNoConfirmation = 4 And $iHits = 1 Then $iIndex = 0

			; Hier wird geprft, ob die Bedingungen fr die "Automatik" gegeben sind (nur 1 Titel, oder ein genauer Treffer). Wenn das nicht der Fall ist, wird die GUI erstellt.
			If ($sNoConfirmation = 1 And $sNoConfirmation <> 3 And $iHits = 1 And $iIndex <> -1) Or ($sNoConfirmation <> 1 And $sNoConfirmation <> 3 And $iHits > 0 And $iIndex <> -1) Then
				ToolTip($aResultnames[$iIndex][1] & $sExtension & " wird automatisch bernommen.." & ' (' & $iGlobalRun & '/' & $aMovies[0] & ')', @DesktopWidth / 2 - 125, @DesktopHeight / 2, $sName)
				If $sBorrowing = 1 And $sFilename & $sExtension <> _WindowsCleanup($aResultnames[$iIndex][1]) & $sExtension Then ; _WindowsCleanup soll verhindern, dass von Windows nicht akzeptierte Zeichen im Dateinamen landen.
					FileWrite(StringTrimRight(@ScriptDir, 3) & "Data\Ignorierliste.txt", $sFilename & @CRLF)
					If $sUnderlines = 1 Then
						FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\" & StringReplace(_WindowsCleanup($aResultnames[$iIndex][1]), " ", "_") & $sExtension)
						$sFilename = StringReplace(_WindowsCleanup($aResultnames[$iIndex][1]), " ", "_")
					Else
						FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\" & _WindowsCleanup($aResultnames[$iIndex][1]) & $sExtension)
						$sFilename = _WindowsCleanup($aResultnames[$iIndex][1])
					EndIf
				EndIf

				; Nun wird die Detailsuche-Funktion mit den Parametern gestartet.
				_GetMovieInfo($aResultnames[$iIndex][2], $aResultnames[$iIndex][1], $aResultnames[$iIndex][3])
				FileWrite(StringTrimRight(@ScriptDir, 3) & "Data\Ignorierliste.txt", $sFilename & @CRLF)
				ToolTip("")
				Return
			EndIf
		EndIf
		ToolTip("")
		; Wenn "Automatik" auf zwei steht, wird bei unklaren Ergebnissen keine GUI erstellt. Das Skript bergeht die nchsten Schritte einfach.
		If $sNoConfirmation <> 3 And $sNoConfirmation <> 4 Then
			; Hier kommt die GUI
			#Region GUI
			$hGUI = GUICreate("Suche: " & $sMoviename, 400, 450)
			GUISetIcon(@ScriptDir & "Other\Icon.ico")
			GUISetBkColor(0x464646, $hGUI)
			GUICtrlSetDefColor(0xFFD948, $hGUI)
			$idEdit = GUICtrlCreateLabel("Suchbegriff bearbeiten", 20, 10, 80, 40)
			$idIgnoreOnce = GUICtrlCreateLabel("Zum nchsten Titel", 170, 10, 80, 40)
			$idIgnoreAllways = GUICtrlCreateLabel("Titel dauerhaft ignorieren", 320, 10, 80, 40)
			$idWorking = GUICtrlCreateLabel("", 0, 0, 400, 40)
			GUICtrlSetBkColor($idWorking, 0xFFD948)
			GUICtrlSetState($idWorking, $GUI_HIDE)
			GUICtrlCreateLabel("Suche luft, bitte warten..", 90, 210, 275, 30)
			GUICtrlSetFont(-1, 12, 800)
			GUICtrlSetState(-1, $GUI_DISABLE)
			GUISetState(@SW_SHOW, $hGUI)
			$hChild = GUICreate("", 400, 400, 0, 50, $WS_POPUP, $WS_EX_MDICHILD, $hGUI)
			GUISetBkColor(0x404040, $hChild)
			GUICtrlSetDefColor(0xD8E7F5, $hChild)
			#EndRegion GUI

			; Hier werden die Controls (anklickbare Bilder und Labels) in einer Schleife erstellt, wenn es Treffer gibt.
			If $iHits <> 0 Then
				For $i = 0 To $iHits - 1
					$test = InetGet($aResultnames[$i][0], @ScriptDir & "\Pic" & $i, 1, 1)
				Next
				For $i = 0 To 150
					If Not (InetGetInfo($test, $INET_DOWNLOADCOMPLETE)) Then
						Sleep(10)
					Else
						ExitLoop
					EndIf
				Next
				For $i = 0 To $iHits - 1
					$idPic[$i] = GUICtrlCreatePic(@ScriptDir & "\Pic" & $i, 20, $iTop, 75, 100)
					$idLabel[$i] = GUICtrlCreateLabel($aResultnames[$i][1] & " (" & $aResultnames[$i][3] & ")", 110, $iTop + 40, 275, 45)
					GUICtrlSetFont(-1, 10, 600, 0, "Segoe UI", 5)
					FileDelete(@ScriptDir & "\Pic" & $i)
					$iTop += 110
				Next
			Else
				$idLabel = GUICtrlCreateLabel("Keine Ergebnisse..", 110, $iTop + 40, 275, 30)
				GUICtrlSetFont($idLabel, 12, 800)
				GUICtrlSetState($idLabel, $GUI_DISABLE)
			EndIf

			GUISetState(@SW_SHOW, $hChild)

			; Wenn mehr als 3 Bilder dargestellt werden mssen, wird die Scrollbars UDF aufgerufen.
			If $iHits > 3 Then _GUIScrollbars_Generate($hChild, 0, 30 + 110 * $iHits, 0, 0, Default, 7)

			; Hier die While Schleife fr die GUI-Ereignisse.
			While 1
				$hGUIMsg = GUIGetMsg()

				Switch $hGUIMsg
					Case $GUI_EVENT_CLOSE
						ExitLoop
					Case $idEdit
						$sNewMovie = InputBox("Suchbegriff", "Hier kannst du den Suchbegriff modifizieren, um bessere Ergebnisse zu erhalten.", $sMoviename)
						If $sNewMovie <> "" And $sNewMovie <> $sMoviename Then
							GUIDelete($hGUI)
							GUIDelete($hChild)
							_SearchMovies($sNewMovie)
							Return
						EndIf
					Case $idIgnoreOnce
						GUIDelete($hGUI)
						GUIDelete($hChild)
						Return
					Case $idIgnoreAllways
						FileWrite(StringTrimRight(@ScriptDir, 3) & "Data\Ignorierliste.txt", $sFilename & @CRLF)
						GUIDelete($hGUI)
						GUIDelete($hChild)
						Return
				EndSwitch

				; Hier wird kontrolliert, welches der in Schleife erstellten Controls angeklickt wurde.
				If $hGUIMsg > 0 Then
					For $i = 0 To $iHits - 1
						If ($hGUIMsg = $idPic[$i]) Or ($hGUIMsg = $idLabel[$i]) Then
							GUICtrlSetState($idWorking, $GUI_SHOW)

							; Hier werden wieder Einstellungen berprft. Soll die Datei umbenannt werden, wenn ja, wie?
							If $sBorrowing = 1 And $sFilename & $sExtension <> _WindowsCleanup($aResultnames[$i][1]) & $sExtension Then
								FileWrite(StringTrimRight(@ScriptDir, 3) & "Data\Ignorierliste.txt", $sFilename & @CRLF)
								If $sUnderlines = 1 Then
									FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & StringReplace(_WindowsCleanup($aResultnames[$i][1]), " ", "_") & $sExtension)
									$sFilename = StringReplace(_WindowsCleanup($aResultnames[$i][1]), " ", "_")
								Else
									FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\" & _WindowsCleanup($aResultnames[$i][1]) & $sExtension)
									$sFilename = _WindowsCleanup($aResultnames[$i][1])
								EndIf
							EndIf

							; Die Film-Detailinformationen werden in der _GetMovieInfo-Funktion abgerufen.
							_GetMovieInfo($aResultnames[$i][2], $aResultnames[$i][1], $aResultnames[$i][3])
							FileWrite(StringTrimRight(@ScriptDir, 3) & "Data\Ignorierliste.txt", $sFilename & @CRLF)
							GUIDelete($hGUI)
							GUIDelete($hChild)
							Return
						EndIf
					Next
				EndIf
			WEnd
		Else
			Return
		EndIf
		; MediaInfo.dll wird vor dem Beenden freigegeben.
		DllCall($hDLL, "none", "MediaInfo_Close", "ptr", $hMediaInfo)
		DllClose($hDLL)

		Exit
	Else
		MsgBox(0, $sMoviename, "0 Ergebnisse")
	EndIf
EndFunc   ;==>_SearchMovies


Func _GetMovieInfo($sAdress, $Moviename, $Year)

	; Fr die die sptere bergabe an IMDB wird hier der Treffertitel gespeichert, bevor er spter mglicherweise wegen Option verndert wird
	$sFoundTitel = $Moviename


	$sSearch = _INetGetSource($sAdress, True)

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	$dBinary = StringToBinary($sSearch)
	$sConverted = BinaryToString($dBinary, 4)

	Local $aMoviedetails[1][3], $sGenre, $sFSK = 0, $iFSKFound = ""

	; In den folgenden Zeilen, werden die Filminformationen aus dem Quelltext gelesen.
	$aGenre = _StringBetween($sConverted, '<span itemprop="genre">', '</span>') ; Hier wird das Genre geholt..


	For $i = 0 To UBound($aGenre) - 1
		$sGenre &= $aGenre[$i] & ","
	Next
	$aMoviedetails[0][2] = StringTrimRight($sGenre, 1)

	$aMainGenre = StringSplit($aMoviedetails[0][2], ",")
	$sMainGenre = _GenreNumber($aMainGenre[1])

	$aResultSplit = StringSplit($sConverted, @LF)

	For $i = 0 To UBound($aResultSplit) - 1

		If StringInStr($aResultSplit[$i], '<div class="poster" >') Then ; <div class="poster dient mir als Anzeige, dass zwei Zeilen darunter der Bildlink zu finden ist.
			$aPicture = _StringBetween($aResultSplit[$i + 2], "<img src='", "'")
			$aMoviedetails[0][0] = $aPicture[0]
		EndIf
		If StringInStr($aResultSplit[$i], 'FSK ab') Then
			$iFSKFound = 1
			$aFSKsplit = StringSplit(_TextCleanup($aResultSplit[$i]), " ")
			If Not $aFSKsplit[4] = "" Then $sFSK = $aFSKsplit[4]
			For $ii = $i To UBound($aResultSplit) - 1
				If StringInStr($aResultSplit[$ii], 'itemprop="description">') Then
					$aMoviedetails[0][1] = $aResultSplit[$ii + 1]
					ExitLoop
				EndIf
			Next
			ExitLoop
		EndIf
		; Falls keine FSK Angabe vorhanden ist, stehen die Infos2 unter 'Inhaltsangabe &amp; Details'
		If $iFSKFound = "" Then
			If StringInStr($aResultSplit[$i], 'Inhaltsangabe &amp; Details') Then
				For $ii = $i To UBound($aResultSplit) - 1
					If StringInStr($aResultSplit[$ii], 'itemprop="description">') Then
						$aMoviedetails[0][1] = $aResultSplit[$ii + 1]
						ExitLoop
					EndIf
				Next
			EndIf
		EndIf
	Next

	; Hier wird einfach mal das Genre in $Info1 gespeichert, weil gleich gefragt werden soll, ob evtl. der Titel 2 in Info1 stehen soll.
	$sInfo1 = $aMoviedetails[0][2]

	; Hier wird ob etwas in $Info1 eingetragen werden soll und wenn ja, was?
	If $sInfo1Option = 0 Then
		$sInfo1 = ""
		; Hier wird geprft, ob die Option Titel statt Genre in Info1 aktiviert ist.
	ElseIf $sInfo1Option = 1 Then
		If StringInStr($Moviename, ": ") Or StringInStr($Moviename, " - ") Then
			$sQuestion = MsgBox(4, "Frage zum Titel", "Der Titel: " & $Moviename & " beeinhaltet :/- " & @CRLF & "Soll nur der erste Teil als Name verwendet werden und statt dem Genre, der zweite Teil in Info1 stehen?")
			; Wenn die Frage mit 'Ja' beantwortet wurde, wird der Titel gesplittet und Name mit Split1 gefllt und die Variable $Info1 mit Split2.
			If $sQuestion = 6 Then
				If StringInStr($Moviename, ": ") Then
					$aName = StringSplit($Moviename, ":")
					$Moviename = $aName[1]
					$sInfo1 = StringTrimLeft($aName[2], 1)
				EndIf
				If StringInStr($Moviename, " - ") Then
					$aName = StringSplit($Moviename, "-")
					$Moviename = StringTrimRight($aName[1], 1)
					$sInfo1 = StringTrimLeft($aName[2], 1)
				EndIf
			EndIf
		EndIf
	EndIf

	; Hier und in folgenden Schritten wird geprft, ob die Ergebnisse in ein separates Verzeichnis gespeichert werden sollen. Wenn ja, wird es hier erstellt.
	If $sNoExtraFolder <> 1 Then DirCreate($sDrive & $sDir & "\" & $sName & "_Ergebnisse")

	; Hier wird das Bild geladen, wenn die Daten vorhanden sind.
	If $sNoExtraFolder = 1 Then
		If $sOutputFilter <> 3 And $aMoviedetails[0][0] <> "" Then InetGet($aMoviedetails[0][0], $sDrive & $sDir & "\" & $sFilename & ".jpg", 1, 1)
	Else
		If $sOutputFilter <> 3 And $aMoviedetails[0][0] <> "" Then InetGet($aMoviedetails[0][0], $sDrive & $sDir & "\" & $sName & "_Ergebnisse\" & $sFilename & ".jpg", 1, 1)
	EndIf

	If $sOutputFilter <> 2 Then
		_MediaInfo()

		If $sIMDB_Infos <> 0 Then
			_LoadIMDB($sFoundTitel, $Year)
		Else
			$sReleaseYear = "0"
			$sCountry = ""
			$sRating = "0"
		EndIf

		; Hier wird die XML geschrieben.
		If $sNoExtraFolder = 1 Then
			$hXML = FileOpen($sDrive & $sDir & "\" & $sFilename & ".xml", 266)
		Else
			$hXML = FileOpen($sDrive & $sDir & "\" & $sName & "_Ergebnisse\" & $sFilename & ".xml", 266)
		EndIf
		If $hXML <> -1 Then
			FileWrite($hXML, '<?xml version="1.0" encoding="UTF-8"?>' & @LF & @LF & '<neutrino commandversion="1">' & @LF & '	<record command="record">' & @LF & '		<channelname>Movieplayer</channelname>' & @LF & '		<epgtitle>')
			FileWrite($hXML, $Moviename & '</epgtitle>' & @LF & '		<id>0</id>' & @LF & '		<info1>' & $sInfo1 & '</info1>' & @LF & '		<info2>' & _TextCleanup($aMoviedetails[0][1]) & $sExtFileData & '</info2>' & @LF)
			FileWrite($hXML, '		<epgid>0</epgid>' & @LF & '		<mode>0</mode>' & @LF & '		<videopid>0</videopid>' & @LF & '		<videotype>0</videotype>' & @LF)

			; Mit eingefgten Audiospuren, hat die Box Probleme. Daher erst einmal nur als Option bernommen.
			If $sAudioInfos = 1 Then FileWrite($hXML, '		<audiopids>' & @LF & $sSoundtrack & '		</audiopids>' & @LF)

			FileWrite($hXML, '		<vtxtpid>0</vtxtpid>' & @LF & '		<genremajor>' & $sMainGenre & '</genremajor>' & @LF & '		<genreminor>0</genreminor>' & @LF)
			FileWrite($hXML, '		<seriename></seriename>' & @LF & '		<length>' & $sDuration & '</length>' & @LF & '		<productioncountry>' & $sCountry & '</productioncountry>' & @LF & '		<productiondate>' & $sReleaseYear & '</productiondate>' & @LF & '		<rating>' & $sRating & '</rating>' & @LF & '		<quality>0</quality>' & @LF)
			FileWrite($hXML, '		<parentallockage>' & $sFSK & '</parentallockage>' & @LF & '		<dateoflastplay></dateoflastplay>' & @LF & '		<bookmark>' & @LF & '			<bookmarkstart>0</bookmarkstart>' & @LF & '			<bookmarkend>0</bookmarkend>' & @LF)
			FileWrite($hXML, '			<bookmarklast>0</bookmarklast>' & @LF & '			<bookmarkuser bookmarkuserpos="0" bookmarkusertype="0" bookmarkusername=""/>' & @LF & '		</bookmark>' & @LF & '	</record>' & @LF & '</neutrino>' & @LF)
			FileClose($hXML)
		Else
			MsgBox(0, $sFilename & ".xml", "Fehler beim Schreiben der Daten.", 5)
		EndIf
	EndIf
EndFunc   ;==>_GetMovieInfo

Func _LoadIMDB($sMoviename, $Year)
	$sSearchname = _ascii($sMoviename)
	Local $Adress = "http://www.imdb.com/find?ref_=nv_sr_fn&q=" & StringReplace($sSearchname, " ", "+") & "&s=all", $sSearch = _INetGetSource($Adress, True), $sFilmAdress = "", $iHits = 1
	Local $iIMDB_Hits = "", $PerfectMatch = "" ; $PerfectMatch ist das Flag fr erfolgreiche Suche

	$sReleaseYear = "0"
	$sCountry = ""
	$sRating = "0"

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	$dBinary = StringToBinary($sSearch)
	$sSearch = BinaryToString($dBinary, 4)

	; Falls Schauspieler mit dem Filmtitel als Spitznamen gelistet sind, muss die Suche etwas gendert werden.
	If StringInStr($sSearch, '<h3 class="findSectionHeader"><a name="nm"></a>Names</h3>') Then

		$aResults = _StringBetween($sSearch, '</a>Titles</h3>' & @LF & '<table class="findList">', '</tr></table>') ; mit Schauspielern
	Else
		$aResults = _StringBetween($sSearch, '<table class="findList">', '</tr></table>')
	EndIf

	If @error Then
		ConsoleWrite(@ScriptLineNumber & ': Keine IMDB Filmliste gefunden bei ' & $sMoviename)
		$iHits = 0

	EndIf
	If $iHits <> 0 Then
		Local $aPics = _StringBetween($aResults[0], '<img src="', '" />')
		Local $aMovieAdress = _StringBetween($aResults[0], 't"> <a href="', '" >')
		Local $aMovies = _StringBetween($aResults[0], ' <a href="', ' </td>')
		Local $aMovieInfos[0][4]
		Local $iCount = 0
		For $i = 0 To UBound($aMovies) - 1

			If Not StringInStr($aMovies[$i], '<img src=') Then

				$aSplit = StringSplit($aMovies[$i], '>')
				$aSplit[3] = StringReplace($aSplit[3], '<br/', '')
				$sSplit = StringTrimRight($aSplit[2], 3) & '|' & $aSplit[3] & '|' & $aPics[$iCount] & '|' & $aMovieAdress[$iCount]
				_ArrayAdd($aMovieInfos, $sSplit, 0, '|')
				$iCount += 1
			EndIf
		Next

		; Erster Schritt der Suche: Perfekter Match. Es wird nach identischer Schreibweise im Namen gesucht.
		$aPerfectName = _ArrayFindAll($aMovieInfos, $sMoviename, 0, 0, 0, 0, 0)
		If Not @error Then
			Local $iMaxvalue = _ArrayMax($aPerfectName)
			; Gibt es bei den genauen Namen auch das richtige Jahr?
			$aPerfectYear = _ArrayFindAll($aMovieInfos, ' (' & $Year & ')', $aPerfectName[0], $iMaxvalue, 0, 0, 1)
			If Not @error Then
				; Wenn es nur einen Treffer mit korrektem Namen und Jahr gibt, wird der Titel bernommen
				If UBound($aPerfectYear) = 1 Then
					$iIMDB_Hits = 1
					$aSearchindex = $aPerfectYear[0]
					$PerfectMatch = 1
				EndIf
			EndIf
		EndIf

		If $PerfectMatch = "" Then
			$aSearchindex = _ArrayFindAll($aMovieInfos, $sMoviename, 0, 0, 0, 1, 0)

			If Not @error Then
				$iIMDB_Hits = UBound($aSearchindex)
			Else
				$aSearchindex2 = _ArrayFindAll($aMovieInfos, ' (' & $Year & ')', 0, 0, 0, 1, 1)
				If @error Then
					$iIMDB_Hits = UBound($aMovieInfos)
					Local $aSearchindex[$iIMDB_Hits]
					For $i = 0 To $iIMDB_Hits - 1
						$aSearchindex[$i] = $i
					Next
				Else
					$iIMDB_Hits = UBound($aSearchindex2)
					Local $aSearchindex[$iIMDB_Hits]
					For $i = 0 To $iIMDB_Hits - 1
						$aSearchindex[$i] = $aSearchindex2[$i]
					Next
				EndIf
			EndIf
		EndIf

		If $iIMDB_Hits = 1 Then
			$sFilmAdress = 'http://www.imdb.com' & $aMovieInfos[$aSearchindex][3]
		EndIf
	EndIf
	If $iIMDB_Hits <> 1 Then
		Local $iTop = 30, $idPic[$iIMDB_Hits], $idLabel[$iIMDB_Hits]

		; Wenn "Automatik" auf zwei steht, wird bei unklaren Ergebnissen keine GUI erstellt. Das Skript bergeht die nchsten Schritte einfach.
		If $sNoConfirmation <> 3 And $sNoConfirmation <> 4 Then


			Local $DownloadTest
			For $i = 0 To $iIMDB_Hits - 1
				$iIndex = $aSearchindex[$i]
				$DownloadTest = InetGet($aMovieInfos[$iIndex][2], @ScriptDir & "\Pic" & $i, 1, 1)
			Next
			For $i = 0 To 150
				If Not (InetGetInfo($DownloadTest, $INET_DOWNLOADCOMPLETE)) Then
					Sleep(10)
				Else
					ExitLoop
				EndIf
			Next
			ToolTip("")
			; Hier kommt die GUI
			#Region GUI
			$hGUI = GUICreate("IMDB-Suche nicht eindeutig: " & $sMoviename, 400, 450)
			GUISetIcon(@ScriptDir & "Other\Icon.ico")
			GUISetBkColor(0x464646, $hGUI)
			GUICtrlSetDefColor(0xFFD948, $hGUI)
			$idEdit = GUICtrlCreateLabel("Suchbegriff bearbeiten", 20, 10, 80, 40)
			$idIgnoreOnce = GUICtrlCreateLabel("bergehen", 170, 10, 80, 40)
			$idWorking = GUICtrlCreateLabel("", 0, 0, 400, 40)
			GUICtrlSetBkColor($idWorking, 0xFFD948)
			GUICtrlSetState($idWorking, $GUI_HIDE)
			GUISetState(@SW_SHOW, $hGUI)
			$hChild = GUICreate("", 400, 400, 0, 50, $WS_POPUP, $WS_EX_MDICHILD, $hGUI)
			GUISetBkColor(0x282828, $hChild)
			GUICtrlSetDefColor(0xD8E7F5, $hChild)
			#EndRegion GUI

			; Hier werden die Controls (anklickbare Bilder und Labels) in einer Schleife erstellt, wenn es Treffer gibt.
			If $iHits <> 0 Then

				For $i = 0 To $iIMDB_Hits - 1
					$iIndex = $aSearchindex[$i]
					$test = InetGet($aMovieInfos[$iIndex][2], @ScriptDir & "\Pic" & $i, 1, 0)
					$idPic[$i] = GUICtrlCreatePic(@ScriptDir & "\Pic" & $i, 20, $iTop, 50, 75)
					$idLabel[$i] = GUICtrlCreateLabel($aMovieInfos[$iIndex][0] & $aMovieInfos[$iIndex][1], 110, $iTop + 25, 275, 45)
					GUICtrlSetFont(-1, 10, 600, 0, "Segoe UI", 5)
					FileDelete(@ScriptDir & "\Pic" & $i)
					$iTop += 85
				Next
			Else
				$idLabel = GUICtrlCreateLabel("Keine Ergebnisse..", 110, $iTop + 40, 275, 30)
				GUICtrlSetFont($idLabel, 12, 800)
				GUICtrlSetState($idLabel, $GUI_DISABLE)
			EndIf

			GUISetState(@SW_SHOW, $hChild)

			; Wenn mehr als 3 Bilder dargestellt werden mssen, wird die Scrollbars UDF aufgerufen.
			If $iIMDB_Hits > 3 Then _GUIScrollbars_Generate($hChild, 0, 30 + 85 * $iIMDB_Hits, 0, 0, Default, 7)

			; Hier die While Schleife fr die GUI-Ereignisse.
			While 1
				$hGUIMsg = GUIGetMsg()

				Switch $hGUIMsg
					Case $GUI_EVENT_CLOSE
						Return
					Case $idEdit
						$sNewMovie = InputBox("Suchbegriff", "Hier kannst du den Suchbegriff modifizieren, um bessere Ergebnisse zu erhalten.", $sMoviename)
						If Not @error Then
							If $sNewMovie <> "" And $sNewMovie <> $sMoviename Then
								MsgBox(0, $sNewMovie, $sMoviename)
								GUIDelete($hGUI)
								GUIDelete($hChild)
								_LoadIMDB($sNewMovie, $Year)
								Return
							EndIf
						Else
							MsgBox(0, $sNewMovie, $sMoviename)
						EndIf
					Case $idIgnoreOnce
						GUIDelete($hGUI)
						GUIDelete($hChild)
						Return
				EndSwitch

				; Hier wird kontrolliert, welches der in Schleife erstellten Controls angeklickt wurde.
				If $hGUIMsg > $idEdit Then
					For $i = 0 To $iIMDB_Hits - 1
						If ($hGUIMsg = $idPic[$i]) Or ($hGUIMsg = $idLabel[$i]) Then
							$sFilmAdress = 'http://www.imdb.com' & $aMovieInfos[$i][3]
							GUIDelete($hGUI)
							GUIDelete($hChild)
						EndIf
					Next
					ExitLoop
				EndIf
			WEnd
		Else
			Return
		EndIf
	EndIf
	$sSearch = _INetGetSource($sFilmAdress, True)

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	$dBinary = StringToBinary($sSearch)
	$sSearch = BinaryToString($dBinary, 4)

	$aResult = _StringBetween($sSearch, 'class="rating">', '<span')
	If Not @error Then
		$sRating = $aResult[0]
	Else
		ConsoleWrite(@ScriptLineNumber & ': Suchstring fr "Rating" nicht gefunden bei ' & $sMoviename)
		$sRating = 0
	EndIf
	$aResult = _StringBetween($sSearch, 'Country:</h4>', '</a>')
	If @error Then
		ConsoleWrite(@ScriptLineNumber & ': Erster Suchstring fr "Country" nicht gefunden bei ' & $sMoviename)
	Else
		$aResultSplit = StringSplit($aResult[0], '>')
		If Not @error Then
			$sCountry = $aResultSplit[2]
		Else
			ConsoleWrite(@ScriptLineNumber & ': Suchstring fr "Country" nicht gefunden bei ' & $sMoviename)
			$sCountry = ''
		EndIf
	EndIf

	$aResult = _StringBetween($sSearch, '<title>', '</title>')
	If @error Then
		ConsoleWrite(@ScriptLineNumber & ': Erster Suchstring fr "Year" nicht gefunden bei ' & $sMoviename)
	Else
		$aResult = _StringBetween($aResult[0], '(', ')')
		If Not @error Then
			$sReleaseYear = $aResult[0]
		Else
			ConsoleWrite(@ScriptLineNumber & ': Zweiter Suchstring fr "Year" nicht gefunden bei ' & $sMoviename)
			$sReleaseYear = 0
		EndIf
	EndIf

EndFunc   ;==>_LoadIMDB

Func _TextCleanup(ByRef $sString)
	For $i = 0 To UBound($aSubstitutes) - 1
		$sString = StringReplace($sString, $aSubstitutes[$i][0], $aSubstitutes[$i][1])
	Next
	Return $sString
EndFunc   ;==>_TextCleanup

Func _WindowsCleanup($sString)
	For $i = 0 To 8
		$sString = StringReplace($sString, $aWindowsCleanup[$i][0], "")
	Next
	If $sCharset = 1 Then
		$dBinary = StringToBinary($sString, 4)
		$sString = BinaryToString($dBinary)
	EndIf
	Return $sString
EndFunc   ;==>_WindowsCleanup

Func _GenreNumber($sGenreText)
	For $i = 0 To UBound($aGenreNumbers) - 1
		$sGenreText = StringReplace($sGenreText, $aGenreNumbers[$i][0], $aGenreNumbers[$i][1])
		If @extended <> 0 Then Return $aGenreNumbers[$i][1]
	Next
	Return 0
EndFunc   ;==>_GenreNumber

Func _ChannelCleanup($sMoviename)
	For $i = 0 To $iSearchlines - 2
		$sNewMoviename = StringReplace($sMoviename, $aChannels[$i], "", 1, 1)
		If @extended <> 0 Then Return $sNewMoviename
	Next
	Return $sMoviename
EndFunc   ;==>_ChannelCleanup

Func _ascii($sString)
	For $i = 0 To UBound($aAscii) - 1
		$sString = StringReplace($sString, $aAscii[$i][0], $aAscii[$i][1], 0, 1)
	Next
	Return $sString
EndFunc   ;==>_ascii

Func _MediaInfo()

	; Hier werden die Mediafile-Informationen mithilfe der MediaInfo.dll abgerufen. Bei Fragen am besten die dll direkt von der Projektseite laden. Da gibt es Beispiele anbei.

	DllCall($hDLL, "dword", "MediaInfo_Open", "ptr", $hMediaInfo, "wstr", $sDrive & $sDir & $sFilename & $sExtension)
	; Wenn "MediaInfotext" aktiviert ist, werden hier die Mediafile-Informationen als Textdatei geschrieben.
	If ($sMediaInfoText = 1) Or ($sMediaInfoText = 2) Then
		If $sNoExtraFolder = 1 Then
			DirCreate($sDrive & $sDir & "\MediaInfo-Ausgaben")
			FileDelete($sDrive & $sDir & "\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt")
			$aMediaInfoInform = DllCall($hDLL, "wstr", "MediaInfo_Inform", "ptr", $hMediaInfo, "int", 0)
			FileWrite($sDrive & $sDir & "\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt", $aMediaInfoInform[0])
		Else
			DirCreate($sDrive & $sDir & "\" & $sName & "_Ergebnisse\MediaInfo-Ausgaben")
			FileDelete($sDrive & $sDir & "\" & $sName & "_Ergebnisse\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt")
			$aMediaInfoInform = DllCall($hDLL, "wstr", "MediaInfo_Inform", "ptr", $hMediaInfo, "int", 0)
			FileWrite($sDrive & $sDir & "\" & $sName & "_Ergebnisse\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt", $aMediaInfoInform[0])
		EndIf
	EndIf
	; Ende Textausgabe

	If ($sExtInfo = 1) And Not ($sMediaInfoText = 2) Then
		; Generelle Dateiangaben
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 0, "int", 0, "wstr", "Format", "int", 1, "int", 0)
		$sFormat = $aMediaInfoGet[0]
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "CodecID", "int", 1, "int", 0)
		$sVideoCodec = $aMediaInfoGet[0]
		If $sVideoCodec = 2 Then $sVideoCodec = "MPEG-2"
		If $sVideoCodec = 27 Then $sVideoCodec = "MPEG-4-AVC"
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "Width", "int", 1, "int", 0)
		$sWidth = $aMediaInfoGet[0]
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "Height", "int", 1, "int", 0)
		$sHeight = $aMediaInfoGet[0]
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "BitRate/String", "int", 1, "int", 0)
		If $aMediaInfoGet[0] <> "" Then
			$sBitRate = " | " & "Videobitrate: " & StringTrimRight(StringReplace($aMediaInfoGet[0], " ", "."), 5) & " Kbps"
		Else
			$sBitRate = ""
		EndIf
		If $sFormat <> "" Then $sExtFileData = @CRLF & "Container: " & $sFormat & " | " & "Codec: " & $sVideoCodec & " | " & "Auflsung: " & $sWidth & "x" & $sHeight & $sBitRate
	EndIf
	If ($sMediaInfoText = 3) Then
		If $sWidth <> "" Then
			$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "Width", "int", 1, "int", 0)
			$sWidth = $aMediaInfoGet[0]
			If $sWidth >= 1920 Then FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\Full HD\" & $sFilename & $sExtension, 8)
			If $sWidth >= 1280 And $sWidth < 1920 Then FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\HD Ready\" & $sFilename & $sExtension, 8)
			If $sWidth < 1280 Then FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\SD\" & $sFilename & $sExtension, 8)
		EndIf
	EndIf

	; Hier rufe ich die Dauer und bilde die Angabe, die MediaInfo ausgibt. Das Ergebnis unterscheidet sich hier aber von Neutrino. Neutrino rundet auf und ab. MediaInfo nimmt die vollstndigen Minuten. Das passt auch zu den offiziellen Angaben.
	$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 0, "int", 0, "wstr", "Duration", "int", 1, "int", 0)
	$sDuration = $aMediaInfoGet[0]
	$sDuration = Round($sDuration / 60000, 1)
	If StringInStr($sDuration, ".") Then $sDuration = StringTrimRight($sDuration, 2)


	; Mit eingefgten Audiospuren, hat die Box momentan Probleme. Daher erst einmal nur als Option bernommen.
	If $sAudioInfos = 1 Then
		; Audiodaten
		$iSelected = 1

		; Es kann maximal 9 Tonspuren geben. Daher luft die Schleife 9 Mal, falls vorher vorher schon keine neue Tonspur gefunden wird.
		For $i = 0 To 9
			If $i <> 0 Then $iSelected = 0
			$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 2, "int", $i, "wstr", "Format", "int", 1, "int", 0)
			If $aMediaInfoGet[0] = "" Then ExitLoop
			$sAudioFormat = $aMediaInfoGet[0]
			$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 2, "int", $i, "wstr", "Language", "int", 1, "int", 0)
			If $aMediaInfoGet[0] = "" Then $aMediaInfoGet[0] = "unbekannt"
			$sLanguage = $aMediaInfoGet[0]
			$sSoundtrack &= '			<audio pid="" audiotype="1" selected="' & $iSelected & '" name="' & $sLanguage & '(' & $sAudioFormat & ')' & '"/>' & @LF
		Next
	EndIf
EndFunc   ;==>_MediaInfo

